<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE Rule PUBLIC "sailpoint.dtd" "sailpoint.dtd">
<Rule language="beanshell" name="BNT-SuccessFactorsEmployees-IdentityAttribute-EmployeeType" type="IdentityAttribute">
  <Description>Identity attribute rules are used when the value is not simply a copy of an application account attribute value.  A transformation may be necessary on the account attribute, or several account attributes may need to be combined to produce the identity attribute.

This rule can be called in two ways: as a global mapping rule and an application mapping rule.  A global mapping rule is called whenever the identity is refreshed.  The rule can look at any account attributes.  An application mapping rule is called only when the identity contains an account link for that application, this link is passed in the "link" argument which is not passed in global mapping rules.</Description>
  <Signature returnType="String">
    <Inputs>
      <Argument name="log" type="org.apache.commons.logging.Log">
        <Description>
          The log object associated with the SailPointContext.
        </Description>
      </Argument>
      <Argument name="context" type="sailpoint.api.SailPointContext">
        <Description>
          A sailpoint.api.SailPointContext object that can be used to query the database if necessary.
        </Description>
      </Argument>
      <Argument name="environment" type="Map">
        <Description>
           Arguments passed to the aggregation or refresh task.
        </Description>
      </Argument>
      <Argument name="identity">
        <Description>
           The Identity object that represents the user
           that is being aggregated.
        </Description>
      </Argument>
      <Argument name="attributeDefinition">
        <Description>
           The AttributeDefinition object for this attribute.
        </Description>
      </Argument>
      <Argument name="link">
        <Description>
           The Link object from the Identity, if this is an application
           mapping rule.  For global mapping rules this will be void.
        </Description>
      </Argument>
      <Argument name="attributeSource">
        <Description>
          The AttributeSource object.
        </Description>
      </Argument>
      <Argument name="oldValue">
        <Description>
          The original value of the application account attribute.
        </Description>
      </Argument>
    </Inputs>
    <Returns>
      <Argument name="attributeValue">
        <Description>
          The value of the attribute that should be populated.
          The rule should return this value.
        </Description>
      </Argument>
    </Returns>
  </Signature>
  <Source><![CDATA[
  import sailpoint.tools.Util;
  import org.apache.log4j.Logger;
  
  
  Logger logger = Logger.getLogger("biontech.rule.BNT-SuccessFactorsEmployees-IdentityAttribute-EmployeeType");
  logger.debug("--- ENTRY ---");
  
  String bntId = link.getAttribute("Person ID External");
  String localEmploymentType = link.getAttribute("LocalEmploymentType");
  String result = null;
  
  if (Util.isNotNullOrEmpty(localEmploymentType)) {
    switch (localEmploymentType) {
      case "6":
        result = "external";
        break;
      case "11":
        result = "internal-contractor";
        break;
      case "17":
        result = "external";
        break;
      default:
        result = "internal-regular";
    }
  } else {
    logger.error("LocalEmploymentType is null for user with BNTID " + bntId);
  }
  
  logger.debug("result=" + result + " for " + link.getAttribute("Person ID External"));
  logger.debug("--- EXIT ---");
  return result;
  ]]></Source>
</Rule>